#include <stdio.h>
#include <windows.h>

#include <filter.h>

#pragma comment(lib, "winmm.lib")

HWAVEOUT hWaveOut = NULL;

WAVEFORMATEX wfe = {};
WAVEHDR whdr = {};

BOOL func_proc(FILTER *fp, FILTER_PROC_INFO *fpip)
{
	// ŏ̌ĂяoA܂FPSςƂwaveOut֐
	FILE_INFO fi;
	fp->exfunc->get_file_info(fpip->editp, &fi);
	if(wfe.nChannels != fi.audio_ch || whdr.dwBufferLength != fi.audio_rate * fi.audio_ch * sizeof(short) / fi.video_rate) {
		if(hWaveOut) {
			waveOutReset(hWaveOut);
			waveOutUnprepareHeader(hWaveOut, &whdr, sizeof(WAVEHDR));
			waveOutClose(hWaveOut);
		}
		hWaveOut = NULL;
		wfe.wFormatTag      = WAVE_FORMAT_PCM;
		wfe.nChannels       = fi.audio_ch;
		wfe.nSamplesPerSec  = fi.audio_rate;
		wfe.nAvgBytesPerSec = sizeof(short) * fi.audio_ch * fi.audio_rate;
		wfe.wBitsPerSample  = sizeof(short) * 8;
		wfe.nBlockAlign     = wfe.nChannels * wfe.wBitsPerSample / 8;
		wfe.cbSize          = 0;
		waveOutOpen(&hWaveOut, WAVE_MAPPER, &wfe, 0, 0, CALLBACK_NULL);

		whdr.dwBufferLength = wfe.nAvgBytesPerSec / fi.video_rate;
	}

	if(!hWaveOut) return TRUE;

	if(!fp->exfunc->is_editing(fpip->editp)) return TRUE;

	// 炷
	whdr.lpData = (LPSTR)fpip->audiop;
	waveOutPrepareHeader(hWaveOut, &whdr, sizeof(WAVEHDR));
	waveOutWrite(hWaveOut, &whdr, sizeof(WAVEHDR));
	return TRUE;
}

BOOL func_exit(FILTER *fp)
{
	waveOutReset(hWaveOut);
	waveOutUnprepareHeader(hWaveOut, &whdr, sizeof(WAVEHDR));
	waveOutClose(hWaveOut);
	return TRUE;
}

FILTER_DLL filter = {
	FILTER_FLAG_AUDIO_FILTER | FILTER_FLAG_NO_CONFIG,
	0, 0,
	"ҏWt[ړɉ炷",
	0, NULL, NULL, NULL, NULL,
	0, NULL, NULL,
	func_proc,
	NULL,
	func_exit,
};

extern "C" __declspec(dllexport) FILTER_DLL *GetFilterTable(void)
{
	return &filter;
}
